package com.onespan.reportingtool.utils;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Calendar;
import java.util.logging.FileHandler;

import com.onespan.reportingtool.data.UserData;

public class StringUtil {

	public static boolean isEmpty(String string) {
		return string == null || string.trim().equals("");
	}
	
	public static byte[] toByteArray(InputStream in) throws IOException {

		ByteArrayOutputStream os = new ByteArrayOutputStream();

		byte[] buffer = new byte[1024];
		int len;

		// read bytes from the input stream and store them in buffer
		while ((len = in.read(buffer)) != -1) {
			// write bytes from the buffer into output stream
			os.write(buffer, 0, len);
		}

		return os.toByteArray();
	}
	
	public static String[] getNames(Class<? extends Enum<?>> e) {
	    return Arrays.toString(e.getEnumConstants()).replaceAll("^.|.$", "").split(", ");
	}
	
	public static String getCurrentTime() {
		SimpleDateFormat format = new SimpleDateFormat("M-d_HHmmss");
		return format.format(Calendar.getInstance().getTime());
	}
	
	public static String removeNullChars(String line) {
	    String result = "";

	    // Convert to char array.
	    char[] chars = line.toCharArray();

	    // Add only chars that are not equal to '\u0000' to result
	    for (int i = 0; i < chars.length; i++) {
	    	int code = (int) chars[i];
	        if (chars[i] != '\u0000' && chars[i] != '\uFEFF') {
	            result += chars[i];
	        }
	    }

	    return result;
	}
	
	public static String removeSlashes(String input) {
		return input.replaceAll("(?<!(http:|https:))[//]+", "/");
	}
	
	public static String fixedLengthString(String string, int length) {
		if(string.length() <= length) {
			return String.format("%1$-"+length+ "s", string);
		}else {
			return string.substring(0, length);
		}
	}

	
}
