package com.onespan.reportingtool.view;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.InputStream;
import java.net.Authenticator;
import java.net.InetSocketAddress;
import java.net.PasswordAuthentication;
import java.net.Proxy;
import java.net.ProxySelector;
import java.net.URI;
import java.util.List;

import javax.imageio.ImageIO;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JProgressBar;
import javax.swing.JTextField;

import com.btr.proxy.selector.pac.PacProxySelector;
import com.btr.proxy.selector.pac.UrlPacScriptSource;
import com.onespan.reportingtool.App;
import com.onespan.reportingtool.data.UserData;
import com.onespan.reportingtool.service.EndpointService;
import com.onespan.reportingtool.service.SenderService;
import com.onespan.reportingtool.utils.InstanceUtil;
import com.onespan.reportingtool.utils.StringUtil;

public class Process1 {

	private JPanel frame;
	private JTextField textField;
	private JTextField textField_2;
	private JTextField url_field;

	private MyButton btnNewButton,btnNextProcess;
	private MyLabel lblSourceEnvironment,lblAppId,lblAppSecret,lblNewLabel_1;
	private OSSProxyPanel ossProxyPanel;
	private JLabel lblNewLabel_2;

	
	/**
	 * Create the application.
	 * @throws IOException 
	 */
	public Process1() throws IOException {
		initialize();
	}

	public JPanel getFrame() {
		return frame;
	}

	public void setLocaleText() {
		lblSourceEnvironment.setText();
		lblAppId.setText();
		lblAppSecret.setText();
		lblNewLabel_1.setText();
		btnNewButton.setText();
		btnNextProcess.setText();
	}
	
	
	/**
	 * Initialize the contents of the frame.
	 * @throws IOException 
	 */
	private void initialize() throws IOException {
		frame = new JPanel();
		frame.setVisible(true);
		frame.setBounds(100, 100, 800, 700);
		frame.setLayout(null);

		lblSourceEnvironment = new MyLabel("environment");
		lblSourceEnvironment.setBounds(114, 280, 120, 38);
		frame.add(lblSourceEnvironment);

		textField = new JTextField();
		textField.setBounds(231, 147, 372, 29);
		frame.add(textField);
		textField.setColumns(10);

		lblAppId = new MyLabel("app_id");
		lblAppId.setBounds(114, 147, 120, 38);
		frame.add(lblAppId);

		lblAppSecret = new MyLabel("app_secret");
		lblAppSecret.setBounds(114, 213, 120, 38);
		frame.add(lblAppSecret);

		textField_2 = new JPasswordField();
		textField_2.setColumns(10);
		textField_2.setBounds(231, 218, 372, 29);
		frame.add(textField_2);

		JProgressBar progressBar = new JProgressBar();
		progressBar.setBounds(589, 11, 144, 14);
		progressBar.setValue(50);
		frame.add(progressBar);

		JLabel progressBarLabel = new JLabel("1/2");
		progressBarLabel.setBounds(744, 11, 46, 14);
		frame.add(progressBarLabel);

		/*Map<String,String> languageMap = new HashMap<String,String>(){{
			put("English", "en");
			put("Brazilian Portuguese", "pt");
			put("Spanish", "es");
		}};
		
		JComboBox comboBox_1 = new JComboBox(languageMap.keySet().toArray(new String[languageMap.size()]));
		comboBox_1.setBounds(570, 36, 134, 20);
		comboBox_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				String language = languageMap.get((String) comboBox_1.getSelectedItem());
				Locale.setDefault(new Locale(language));
				UserData.mybundle = ResourceBundle.getBundle("locale.locale");
//				UserData.locale = new Locale(language);
				App.setTitle();

				ossProxyPanel.setLocaleText();
				setLocaleText();
			}
		});
		
		frame.add(comboBox_1);
		
		lblNewLabel_1 = new MyLabel("language");
		lblNewLabel_1.setBounds(714, 27, 76,38);
		frame.add(lblNewLabel_1);*/
		
		
		
		JComboBox comboBox = new JComboBox();
		comboBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if(((String) comboBox.getSelectedItem()).equals("--Specify your own (for on-prem users)--")) {
					url_field.setVisible(true);
				}else {
					url_field.setVisible(false);
				}
			}
		});
		comboBox.setModel(new DefaultComboBoxModel(InstanceUtil.endPointList.keySet().toArray()));
		comboBox.setBounds(232, 277, 290, 38);
		frame.add(comboBox);

		btnNextProcess = new MyButton("next_process");
		btnNextProcess.setEnabled(false);
		btnNextProcess.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				App.setMainFrame(new Process2().getFrame());
			}
		});
		btnNextProcess.setBounds(495, 602, 152, 38);
		frame.add(btnNextProcess);

		url_field = new JTextField();
		url_field.setBounds(532, 285, 232, 29);
		url_field.setVisible(false);
		frame.add(url_field);
		
		
		btnNewButton = new MyButton("test_connection");
		btnNewButton.setMargin(new Insets(0,0,0,0));
		btnNewButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				btnNewButton.setText(UserData.mybundle.getString("processing"));
				btnNewButton.setEnabled(false);
				comboBox.setEnabled(false);
				
				new Thread(new Runnable() {

					@Override
					public void run() {
						try {
							//environment
							String selectedOption = (String) comboBox.getSelectedItem();
							String url = "";
							if(selectedOption.equals("--Specify your own (for on-prem users)--")) {
								url = url_field.getText().trim() + "/";
							}else {
								url = InstanceUtil.getUrlByKey(selectedOption);
							}
							UserData.setUrl(url);
							
							
							if (!StringUtil.isEmpty(textField.getText())) {
								UserData.ownerCredential.setAppId(textField.getText().trim());
							}
							if (!StringUtil.isEmpty(textField_2.getText())) {
								UserData.ownerCredential.setAppSecret(textField_2.getText().trim());
							}
							
							
							//proxy settings
                           String authUser = ossProxyPanel.proxy_username.getText().trim();
                            String authPassword = ossProxyPanel.proxy_pwd.getText().trim();
                            Authenticator.setDefault(
                              new Authenticator() {
                                @Override
                                public PasswordAuthentication getPasswordAuthentication() {
                                  return new PasswordAuthentication(authUser, authPassword.toCharArray());
                                }
                              }
                            );
                            System.setProperty("http.proxyUser", authUser);
                            System.setProperty("http.proxyPassword", authPassword);
                            System.setProperty("jdk.http.auth.tunneling.disabledSchemes", "");  
								
							
							
							if(ossProxyPanel.rdbtnProxyAutomaticScript.isSelected() && !StringUtil.isEmpty(ossProxyPanel.proxyScript.getText())) {
								UrlPacScriptSource source = new UrlPacScriptSource(ossProxyPanel.proxyScript.getText());
								PacProxySelector proxySelector = new PacProxySelector(source);
								ProxySelector.setDefault(proxySelector);

								URI home = URI.create(InstanceUtil.getUrlByKey((String) comboBox.getSelectedItem()));
								System.out.println("ProxySelector: " + proxySelector);
								System.out.println("URI: " + home);
								List<Proxy> proxyList = proxySelector.select(home);
								if (proxyList != null && !proxyList.isEmpty()) {
									for (Proxy proxy : proxyList) {
										System.out.println(proxy);
										UserData.proxy = proxy;
									}
								}
							}else if(ossProxyPanel.rdbtnProxyHost.isSelected() && !StringUtil.isEmpty(ossProxyPanel.proxyAddress.getText()) && !StringUtil.isEmpty(ossProxyPanel.proxyPort.getText())){
								try {
									UserData.proxy = new Proxy(Proxy.Type.HTTP, new InetSocketAddress(ossProxyPanel.proxyAddress.getText(), Integer.parseInt(ossProxyPanel.proxyPort.getText())));
								}catch(Exception e) {
									
								}
							}else {
								UserData.proxy = null;
							}
							

							EndpointService.getInstance().testConnection();

							SenderService.getInstance().loadAccountInfo();
							
							String returnMsg = UserData.mybundle.getString("key_is_valid");
							if(UserData.proxy!=null) {
								returnMsg += UserData.mybundle.getString("connect_through_proxy") + UserData.proxy.toString();
							}
							// show success dialog
							JOptionPane.showMessageDialog(frame, returnMsg, UserData.mybundle.getString("connect_test_success"),
									JOptionPane.INFORMATION_MESSAGE);
							
							btnNextProcess.setEnabled(true);
							
						} catch (Exception exception) {
							exception.printStackTrace();
							
							// to do
							// show connection test fail dialog
							JOptionPane.showMessageDialog(frame,
									exception.getMessage(),
									UserData.mybundle.getString("connect_test_fail"), JOptionPane.ERROR_MESSAGE);
						} finally {
							btnNewButton.setText();
							btnNewButton.setEnabled(true);
							comboBox.setEnabled(true);
						}
					}
				}).start();

			}

		});
		btnNewButton.setBounds(138, 602, 144, 38);
		frame.add(btnNewButton);
		
		ossProxyPanel = new OSSProxyPanel();
		ossProxyPanel.setBounds(89, 339, ossProxyPanel.getWidth(), ossProxyPanel.getHeight());
		frame.add(ossProxyPanel);
		
		InputStream is = App.class.getResourceAsStream("/img/Logo_OneSpan_eMail.png");
		BufferedImage image = ImageIO.read(is);
		lblNewLabel_2 = new JLabel(new ImageIcon(image));
		lblNewLabel_2.setBounds(0, 0, 372, 97);
		
		frame.add(lblNewLabel_2);
		

		
		
		
	}
}
