package com.onespan.reportingtool.view;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Properties;

import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import org.apache.commons.lang3.StringUtils;
import org.jdatepicker.impl.JDatePanelImpl;
import org.jdatepicker.impl.JDatePickerImpl;
import org.jdatepicker.impl.UtilDateModel;

import com.onespan.reportingtool.App;
import com.onespan.reportingtool.data.UserData;
import com.onespan.reportingtool.service.PackageService;
import com.onespan.reportingtool.service.ReportService;
import com.onespan.reportingtool.utils.StringUtil;

public class Process2 {
	protected static final String JCheckBox = null;

	private JPanel frame;

	JDatePickerImpl from_datepicker, to_datepicker;
	private JLabel lblNewLabel;

	private MyLabel lblDoYouWant_1, lblFrom, lblTo;
	private MyButton selectFolderButton, exportReportButton;
	private JCheckBox senderSpecificReport;
	
	private JScrollPane scrollPane;
	private final JTextArea consoleOutput = new JTextArea();

	/**
	 * Create the application.
	 */
	public Process2() {
		initialize();
	}

	public JPanel getFrame() {
		return frame;
	}

	private void openFileChooseDialog() {
		final JFileChooser fc = new JFileChooser();
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fc.setDialogTitle(UserData.mybundle.getString("where_to_store_export_file"));

		int returnVal = fc.showOpenDialog(getFrame());

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			UserData.folderPath = fc.getSelectedFile().getAbsolutePath();
			File file = new File(fc.getSelectedFile().getAbsolutePath());
			if (!file.exists()) {
				file.mkdirs();
			}
			lblNewLabel.setText("<html>" + UserData.folderPath + "</html>");
			checkEnableGenerateReportButton();
		} else {
			// open cancelled
		}
	}
	
	private void checkEnableGenerateReportButton() {
		if (!StringUtil.isEmpty(UserData.folderPath) && 
				!StringUtil.isEmpty(from_datepicker.getJFormattedTextField().getText()) && 
				!StringUtil.isEmpty(to_datepicker.getJFormattedTextField().getText())) {
			exportReportButton.setEnabled(true);
		}
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		try {
	      OutputStream os = new TextAreaOutputStream(consoleOutput);
	      System.setOut(new PrintStream(os, true, "UTF-8"));
	    } catch (IOException ex) {
	      ex.printStackTrace();
	    }

		consoleOutput.setEditable(false);

		frame = new JPanel();
		App.mainFrame.setBounds(App.mainFrame.getX(), App.mainFrame.getY(), 1230, 750);
		frame.setLayout(null);
		
		scrollPane = new JScrollPane(consoleOutput);
		scrollPane.setBounds(5, 250, App.mainFrame.getWidth() - 25, 400);
		frame.add(scrollPane);
		
		JProgressBar progressBar = new JProgressBar();
		progressBar.setValue(100);
		frame.add(progressBar);

		JLabel progressBarLabel = new JLabel("2/2");

		progressBar.setBounds(App.mainFrame.getWidth() - 40 - 155, 11, 144, 14);
		progressBarLabel.setBounds(App.mainFrame.getWidth() - 40, 11, 46, 14);
		frame.add(progressBarLabel);

		lblDoYouWant_1 = new MyLabel("choose_your_save_folder");
		lblDoYouWant_1.setBounds(25, 80, 175, 46);
		frame.add(lblDoYouWant_1);

		selectFolderButton = new MyButton("select_your_folder_location");
		selectFolderButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				openFileChooseDialog();
			}
		});
		selectFolderButton.setEnabled(false);
		selectFolderButton.setBounds(202, 80, 191, 40);
		selectFolderButton.setMargin(new Insets(0, 0, 0, 0));
		selectFolderButton.setEnabled(true);
		frame.add(selectFolderButton);

		lblFrom = new MyLabel("from");
		lblFrom.setBounds(25, 45, 46, 14);
		frame.add(lblFrom);

		lblTo = new MyLabel("to");
		lblTo.setBounds(265, 45, 61, 14);
		frame.add(lblTo);

		UtilDateModel from_model = new UtilDateModel();
		Properties p = new Properties();
		p.put("text.today", "Today");
		p.put("text.month", "Month");
		p.put("text.year", "Year");
		JDatePanelImpl from_datepanel = new JDatePanelImpl(from_model, p);
		from_datepicker = new JDatePickerImpl(from_datepanel, new DateLabelFormatter());
		from_datepicker.setBounds(90, 40, 150, 29);
		from_datepicker.getJFormattedTextField().getDocument().addDocumentListener(new DocumentListener() {
			
			@Override
			public void removeUpdate(DocumentEvent e) {
				exportReportButton.setEnabled(false);
			}
			
			@Override
			public void insertUpdate(DocumentEvent e) {
				if (!StringUtils.isEmpty(from_datepicker.getJFormattedTextField().getText())) {
					checkEnableGenerateReportButton();
				}
			}
			
			@Override
			public void changedUpdate(DocumentEvent e) {
				
			}
		});
		frame.add(from_datepicker);

		UtilDateModel to_model = new UtilDateModel();
		JDatePanelImpl to_datepanel = new JDatePanelImpl(to_model, p);
		to_datepicker = new JDatePickerImpl(to_datepanel, new DateLabelFormatter());
		to_datepicker.setBounds(318, 40, 150, 29);
		to_datepicker.getJFormattedTextField().getDocument().addDocumentListener(new DocumentListener() {
			
			@Override
			public void removeUpdate(DocumentEvent e) {
				exportReportButton.setEnabled(false);
			}
			
			@Override
			public void insertUpdate(DocumentEvent e) {
				if (!StringUtils.isEmpty(to_datepicker.getJFormattedTextField().getText())) {
					checkEnableGenerateReportButton();
				}
			}
			
			@Override
			public void changedUpdate(DocumentEvent e) {
				
			}
		});
		frame.add(to_datepicker);
		
		lblNewLabel = new JLabel("");
		lblNewLabel.setBounds(42, 120, 520, 14);
		frame.add(lblNewLabel);

		JLabel lblNewLabel_2_1 = new JLabel(UserData.mybundle.getString("sender_specific_report"));
		lblNewLabel_2_1.setBounds(89, 140, 213, 14);
		frame.add(lblNewLabel_2_1);
		
		senderSpecificReport = new JCheckBox();
		senderSpecificReport.setBounds(25, 140, 54, 14);
		frame.add(senderSpecificReport);
	
		exportReportButton = new MyButton("export_as_csv");
		exportReportButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (StringUtil.isEmpty(UserData.folderPath)) {
					JOptionPane.showMessageDialog(frame, UserData.mybundle.getString("choose_target_folder_first"),
							"Oops...", JOptionPane.ERROR_MESSAGE);
					return;
				}

				exportReportButton.setEnabled(false);
				exportReportButton.setText(UserData.mybundle.getString("processing"));
				
				new Thread(new Runnable() {

					@Override
					public void run() {
						try {
							String from = from_datepicker.getJFormattedTextField().getText();
							String to = to_datepicker.getJFormattedTextField().getText();
							
							PackageService.getInstance().loadCompletedPackages(from, to);
							String filePath = ReportService.getInstance().exportReport(from, to, senderSpecificReport.isSelected());
							// show report when copy templates completed
							StringBuilder report = new StringBuilder(200);
							report.append("<html>")
									.append(String.format(UserData.mybundle.getString("report_message"), filePath))
									.append("</html>");

							JOptionPane.showMessageDialog(frame, report.toString(),
									UserData.mybundle.getString("export_report_as_csv"),
									JOptionPane.INFORMATION_MESSAGE);
						} catch (Exception e) {
							e.printStackTrace();
							System.out.println(e.getMessage());
						} finally {
							exportReportButton.setEnabled(true);
							exportReportButton.setText();
						}

					}
				}).start();

			}
		});
		exportReportButton.setMargin(new Insets(0, 0, 0, 0));
		exportReportButton.setEnabled(false);
		exportReportButton.setBounds(25, 175, 163, 53);
		frame.add(exportReportButton);
	}

class TextAreaOutputStream extends OutputStream {
	  private final ByteArrayOutputStream buf = new ByteArrayOutputStream();
	  private final JTextArea consoleOutput;
	  public TextAreaOutputStream(JTextArea consoleOutput) {
	    super();
	    this.consoleOutput = consoleOutput;
	  }
	  @Override public void flush() throws IOException {
	    consoleOutput.append(buf.toString("UTF-8"));
	    buf.reset();
	  }
	  @Override public void write(int b) throws IOException {
	    buf.write(b);
	  }
	}


}
